void* memcpy(void* pDest, void const* pSrc, unsigned short n)
{
    unsigned int wordCount = n >> 2u;

    /* Check pDest and pSrc for word alignment. At the same
       time, check whether n is a multiple of 4 */
    if(0u==(((unsigned int)pDest|(unsigned int)pSrc|n)&3u))
    {
        /* Now use word (1 word = 4 bytes) pointers */
        unsigned int* pD = (unsigned int*)pDest;
        unsigned int const* pS = (unsigned int const*)pSrc;

        while(0u != wordCount--)
        {
            *pD++ = *pS++; /* Copy 4 bytes at a time */
        }
    }
    else
    {
        /* use old implementation of memcpy */
    }
    return pDest;
}